#include<cstdio>
#include<vector>
#include<algorithm>

using namespace std;

const int MAX_M = 100000;
const int MAX_N = 300;

struct edge
{
	int v1;
	int v2;
	long long d;
	int ind;
};
int operator< (const edge &a, const edge &b)
{
	return a.d < b.d;
}

int n, m;
int a[MAX_N][MAX_N];
vector <edge> v;
int root[MAX_N];

void kruskal()
{
	for(int i=1; i<=n; i++)
	{
		root[i]=i;
	}
	sort(v.begin(), v.end());

	int pos=0, count=0, temp;
	while(count<n-1)
	{
		if(root[v[pos].v1]!=root[v[pos].v2])
		{
			temp=root[v[pos].v2];
			for(int i=1; i<=n; i++)
			{
				if(root[i]==temp)
				{
					root[i]=root[v[pos].v1];
				}
			}
			count++;
			printf("%d\n", v[pos].ind);
		}
		pos++;
	}
}

int main()
{
	freopen("graph.in", "r", stdin);
    freopen("graph.out", "w", stdout);


	scanf("%d%d", &n, &m);

	edge e;
	int maxlen = 0;
	for(int i=1; i<=m; i++)
	{
		e.ind = i;
		scanf("%d%d%lld", &e.v1, &e.v2, &e.d);
		v.push_back(e);
		maxlen = e.d > maxlen ? e.d : maxlen;
	}


	for(int i=0; i<n; i++)
	{
		for(int j=0; j<n; j++)
		{
			scanf("%d", &a[i][j]);
		}
	}

	if(maxlen <= 2)
	{
		for(int i=0; i<m; i++)
		{
			v[i].d*=v[i].d*v[i].d*a[v[i].v1][v[i].v2];
		}
	}

	kruskal();

	//for(int i=0; i<v.size(); i++)
	//	printf("%d %d %lld\n", v[i].v1, v[i].v2, v[i].d);
	//
	//for(int i=0; i<n; i++)
	//{
	//	for(int j=0; j<n; j++)
	//	{
	//		printf("%d ", a[i][j]);
	//	}
	//	printf("\n");
	//}

	//system("pause");
	return 0;
}
/*
5 8
2 1 783
3 2 531
2 4 863
4 3 124
1 5 68
2 5 136
5 3 930
4 5 803
0 315634023 635723059 125898168 628175012
315634023 0 369133070 59961394 656478043
635723059 369133070 0 89018457 131176230
125898168 59961394 89018457 0 653377374
628175012 656478043 131176230 653377374 0

*/
